"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./checkbox.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Checkbox =
/*#__PURE__*/
function (_Component) {
  _inherits(Checkbox, _Component);

  function Checkbox(props) {
    var _this;

    _classCallCheck(this, Checkbox);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Checkbox).call(this, props));
    _this.state = {
      isChecked: false,
      isDisabled: false,
      inputValue: false,
      newColor: '',
      colorType: 'primary',
      customProps: {}
    };
    _this.handleChecked = _this.handleChecked.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Checkbox, [{
    key: "setCheckboxTagValue",
    value: function setCheckboxTagValue() {
      if (this.props && this.props.onChange) {
        var value = this.state.isChecked;
        this.props.onChange(value);
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.resolveType();
      this.setDefault();
      this.cleanAttributes();
    }
  }, {
    key: "cleanAttributes",
    value: function cleanAttributes() {
      var properties = Object.assign({}, this.props);
      delete properties.children;
      delete properties.checked;
      delete properties.disabled;
      delete properties.onChange;
      this.setState({
        customProps: properties
      });
    }
  }, {
    key: "setDefault",
    value: function setDefault() {
      var _this$props = this.props,
          checked = _this$props.checked,
          disabled = _this$props.disabled;
      if (checked) this.setState({
        isChecked: checked
      });
      if (disabled) this.setState({
        isDisabled: disabled
      });
    }
  }, {
    key: "resolveType",
    value: function resolveType() {
      var type = this.props.type;
      if (type) this.setState({
        colorType: type
      });
    }
  }, {
    key: "handleChecked",
    value: function handleChecked() {
      var _this2 = this;

      this.setState({
        isChecked: !this.state.isChecked
      }, function () {
        _this2.setCheckboxTagValue(_this2.state.isChecked);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          isChecked = _this$state.isChecked,
          colorType = _this$state.colorType,
          customProps = _this$state.customProps,
          isDisabled = _this$state.isDisabled;
      var children = this.props.children;
      var empty = '';
      return _react["default"].createElement("div", null, _react["default"].createElement("label", {
        className: "nw-checkbox-wrapper ".concat(isDisabled ? '-disabled' : '', " ")
      }, _react["default"].createElement("span", {
        className: "".concat(colorType, " nw-checkbox ").concat(isChecked ? '-checked' : '', " ")
      }, _react["default"].createElement("input", _extends({}, customProps, {
        type: "checkbox",
        className: "nw-checkbox-input",
        onClick: this.handleChecked,
        defaultChecked: isChecked,
        disabled: isDisabled
      })), _react["default"].createElement("span", {
        className: "".concat(colorType, " nw-checkbox-inner ").concat(isChecked ? '-checked' : '', " ")
      })), children ? _react["default"].createElement("span", null, children) : empty));
    }
  }]);

  return Checkbox;
}(_react.Component);
/*|--------------
  | Proptypes
  |-------------- */


exports["default"] = Checkbox;
Checkbox.propTypes = {
  type: _propTypes["default"].string,
  checked: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  onChange: _propTypes["default"].func
};