"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./input.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Input = function Input(props) {
  var _addOnsBuilder = addOnsBuilder(props),
      html = _addOnsBuilder.html,
      settings = _addOnsBuilder.settings;

  var customProps = Object.assign({}, props);
  cleanAttributes(customProps);
  return _react["default"].createElement("span", {
    className: "input-wrap ".concat(withBlock(props.block))
  }, html, _react["default"].createElement("input", _extends({}, customProps, {
    type: "text",
    className: classBuilder(customProps, {
      opts: {
        addOns: settings
      }
    })
  })));
};

var cleanAttributes = function cleanAttributes(customProps) {
  delete customProps.addOnBefore;
  delete customProps.addOnAfter;
  delete customProps.block;
};

var classBuilder = function classBuilder(_ref, _ref2) {
  var className = _ref.className,
      align = _ref.align;
  var opts = _ref2.opts;
  var settings = opts.addOns;
  var nativeClasses = className ? className : '';
  var ownClasses = ['nw-input'].concat(_toConsumableArray(alignment(align)), _toConsumableArray(addOnClasses(settings)));
  ownClasses = ownClasses.join(" ");
  return "".concat(ownClasses, " ").concat(nativeClasses);
};

var addOnsBuilder = function addOnsBuilder(_ref3) {
  var addOnBefore = _ref3.addOnBefore,
      addOnAfter = _ref3.addOnAfter;

  var html = _react["default"].createElement(_react["default"].Fragment, null);

  var exists, position, children;

  switch (true) {
    case addOnBefore !== undefined:
      exists = true;
      position = 'before';
      children = addOnBefore.props.children;
      break;

    case addOnAfter !== undefined:
      exists = true;
      position = 'after';
      children = addOnAfter.props.children;
      break;

    default:
      break;
  }

  ;

  if (addOnBefore || addOnAfter) {
    html = _react["default"].createElement("div", {
      className: "nw-addon -".concat(position)
    }, children);
  }

  return {
    html: html,
    settings: {
      exists: exists,
      position: position
    }
  };
};
/*|--------------
  | Add Classes
  |-------------- */


var addOnClasses = function addOnClasses(settings) {
  var classes = [];
  if (settings.exists) return ["-".concat(settings.position, "-adjust-padding")];
  return classes;
};

var alignment = function alignment(align) {
  var classes = [];
  if (align) return ["-align-".concat(align)];
  return classes;
};

var withBlock = function withBlock(isBlock) {
  var classes = '';
  if (isBlock) return '-block';
  return classes;
};
/*|--------------
  | Proptypes
  |-------------- */


Input.propTypes = {
  align: _propTypes["default"].string,
  block: _propTypes["default"].bool,
  addOnBefore: _propTypes["default"].object,
  addOnAfter: _propTypes["default"].object
};
var _default = Input;
exports["default"] = _default;