"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _helpers = require("./helpers");

require("./colors.scss");

require("./select.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// global variable not included on states.
var _isSelectTagMounted = false;
var _elemOffset = null;
var _selectIsDown = true;
var _gtimeout = null;
var _DEFAULT_LABEL = 'Please select';
var _SELECT_PROPS = ['disabled', 'type', 'size', 'placeholder', 'block', 'nullable', 'data', 'onChange', 'detectBounds'];

var Select =
/*#__PURE__*/
function (_Component) {
  _inherits(Select, _Component);

  function Select(props) {
    var _this;

    _classCallCheck(this, Select);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Select).call(this, props));
    _this.state = {
      isOpen: false,
      currLabel: _DEFAULT_LABEL,
      currValue: undefined,
      size: 6,

      /* default size */
      hasSelection: false,
      data: [],
      tagId: 0,
      placeholder: '',
      isBlock: false,
      isDown: true,
      isNullable: false,
      type: 'primary',
      detectBounds: false,
      customProps: {}
    }; // should use ref

    _this.inputSelf = _react["default"].createRef();
    _this.handleSelectOpener = _this.handleSelectOpener.bind(_assertThisInitialized(_this));
    _this.onWindowResize = _this.onWindowResize.bind(_assertThisInitialized(_this));
    _this.onWindowScroll = _this.onWindowScroll.bind(_assertThisInitialized(_this));
    _this.mainClasses = _this.mainClasses.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Select, [{
    key: "setElemOffsetById",
    value: function setElemOffsetById(id) {
      var elem = document.querySelector("#select-control-".concat(id));

      if (elem) {
        _elemOffset = (0, _helpers.getOffset)(elem);
      }
    }
  }, {
    key: "setSelectTagValue",
    value: function setSelectTagValue() {
      if (this.props && this.props.onChange) {
        var value = {
          value: this.state.currValue,
          label: this.state.currLabel
        };
        this.props.onChange(value);
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      _isSelectTagMounted = true;
      _selectIsDown = true;
      this.setState({
        tagId: (0, _helpers.generateId)()
      }, function () {
        _this2.setElemOffsetById(_this2.state.tagId);
        /*|-------------
          | Init Events
          |-------------*/


        _this2.addWindowEvents();
        /*|---------------------
          | Props Modifications
          |---------------------*/


        _this2.propsModifications();
        /*|---------------------
          | Auto-trigger funct
          |---------------------*/


        _this2.calcHitBounds();
        /*|---------------------
          | Clean Mock Attributes
          |---------------------*/


        _this2.cleanAttributes();
      });
    }
  }, {
    key: "cleanAttributes",
    value: function cleanAttributes() {
      var properties = Object.assign({}, this.props);

      _SELECT_PROPS.forEach(function (name) {
        delete properties[name];
      });

      this.setState({
        customProps: properties
      });
    }
  }, {
    key: "propsModifications",
    value: function propsModifications() {
      var _this3 = this;

      if (_isSelectTagMounted) {
        var _this$props = this.props,
            data = _this$props.data,
            placeholder = _this$props.placeholder,
            block = _this$props.block,
            size = _this$props.size,
            nullable = _this$props.nullable,
            type = _this$props.type,
            detectBounds = _this$props.detectBounds;

        var _size = size || this.state.size;

        var elem = document.querySelector('.select-wrap .nw-option');
        elem.style.maxHeight = +_size * 30 + 'px';
        if (data && data.length) this.setState({
          data: data
        });
        if (placeholder && placeholder.length) this.setState({
          currLabel: placeholder,
          placeholder: placeholder
        });
        if (block) this.setState({
          isBlock: true
        });
        if (nullable) this.setState({
          isNullable: true,
          currValue: undefined
        }, function () {
          return _this3.setSelectTagValue();
        }
        /** autoset */
        );
        if (type && type.length) this.setState({
          type: type
        });
        if (detectBounds) this.setState({
          detectBounds: true
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _isSelectTagMounted = false;
      clearTimeout(_gtimeout);
      this.removeWindowEvents();
    }
  }, {
    key: "removeWindowEvents",
    value: function removeWindowEvents() {
      window.removeEventListener('resize', this.onWindowResize);
      window.removeEventListener('scroll', this.onWindowScroll);
    }
  }, {
    key: "addWindowEvents",
    value: function addWindowEvents() {
      window.addEventListener('resize', this.onWindowResize);
      window.addEventListener('scroll', this.onWindowScroll);
    }
  }, {
    key: "onWindowScroll",
    value: function onWindowScroll() {
      this.calcHitBounds();
    }
  }, {
    key: "calcHitBounds",
    value: function calcHitBounds() {
      if (!_isSelectTagMounted) return; // TODO: There's a glitch by which the scroll snap a bit.

      this.setElemOffsetById(this.state.tagId);
      var offsetY = _elemOffset.top - window.scrollY;
      var windowHeight = window.innerHeight;
      var offsetPixel = 200;
      if (!this.state.detectBounds) return;
      if (offsetY > windowHeight - offsetPixel) _selectIsDown = false;else _selectIsDown = true;
    }
  }, {
    key: "onWindowResize",
    value: function onWindowResize() {
      if (!_isSelectTagMounted && !this.state.tagId) return 0;
      this.setElemOffsetById(this.state.tagId);
    }
  }, {
    key: "handleSelectOpener",
    value: function handleSelectOpener(evt) {
      var _this4 = this;

      if (_isSelectTagMounted) {
        evt.stopPropagation();
        this.setState({
          isOpen: !this.state.isOpen
        }, function () {
          return _this4.inputSelf.current.focus();
        });
      }
    }
  }, {
    key: "resolveNullableData",
    value: function resolveNullableData(data) {
      if (this.state.isNullable) {
        var adoptPlaceholder = this.state.isNullable && this.state.placeholder.length ? this.state.placeholder : _DEFAULT_LABEL;
        data = [{
          value: null,
          label: adoptPlaceholder
        }].concat(_toConsumableArray(data));
      }

      return data;
    }
  }, {
    key: "renderHybridTagOption",
    value: function renderHybridTagOption(data) {
      var _this5 = this;

      data = this.resolveNullableData(data);
      return data.map(function (opt, idx) {
        return _react["default"].createElement("li", {
          key: idx,
          "data-value": opt.value,
          className: _this5.state.currValue === opt.value ? '-active' : '',
          onClick: function onClick(evt) {
            evt.stopPropagation();
            var currValue = evt.target.dataset.value;
            var currLabel = evt.target.innerText;

            _this5.setState({
              currLabel: currLabel,
              currValue: currValue,
              isOpen: false
            }, function () {
              _this5.setSelectTagValue();
            });
          }
        }, opt.label);
      });
    }
  }, {
    key: "renderSelectTagOption",
    value: function renderSelectTagOption(data) {
      data = this.resolveNullableData(data);
      return data.map(function (opt, idx) {
        return _react["default"].createElement("option", {
          key: idx,
          value: opt.value
        }, opt.label);
      });
    }
  }, {
    key: "resolvePrimitiveTheme",
    value: function resolvePrimitiveTheme(type) {
      return;
    }
  }, {
    key: "mainClasses",
    value: function mainClasses(_ref) {
      var className = _ref.className;
      var ownClasses = ['select-wrap -switched', '-'.concat(this.state.type), this.state.isBlock ? '-block' : '', this.state.isOpen ? '-with-border-focus' : ''];
      var nativeClasses = className ? className : '';
      ownClasses = ownClasses.join(" ");
      return "".concat(ownClasses, " ").concat(nativeClasses);
    }
  }, {
    key: "render",
    value: function render() {
      var _this6 = this;

      var _this$state = this.state,
          isOpen = _this$state.isOpen,
          currLabel = _this$state.currLabel,
          data = _this$state.data,
          currValue = _this$state.currValue,
          tagId = _this$state.tagId,
          customProps = _this$state.customProps;
      return _react["default"].createElement("div", _extends({
        id: "select-control-".concat(tagId)
      }, this.props, {
        className: this.mainClasses(customProps),
        onBlur: function onBlur() {// TODO: make check for difference in onBlur from selected.

          /* just found, this can handle onblur from inner input elem
          if(this.state.isOpen){
              _gtimeout = setTimeout(()=>{
                  clearTimeout(_gtimeout);
                  this.setState({isOpen:false});
              }, 250);
          } */
        },
        onClick: function onClick(evt) {
          _this6.handleSelectOpener(evt);
        }
      }), _react["default"].createElement("span", {
        className: "".concat(isOpen ? '-with-focus' : '', " -prevent-pointer -disable-user-select")
      }, _react["default"].createElement("input", _extends({}, customProps, {
        ref: this.inputSelf,
        className: "select-input disable-user-select -not-used -prevent-pointer -disable-user-select",
        value: currLabel,
        onBlur: function onBlur() {
          /* refer: #select-control- */
        },
        onChange: function onChange() {
          _this6.setState({
            currValue: currValue
          });
        }
      })), _react["default"].createElement("div", {
        className: "div-label \n                        -prevent-pointer -disable-user-select"
      }, _react["default"].createElement("div", null, currLabel))), _react["default"].createElement("select", {
        id: "nw-select-tag-".concat(tagId),
        className: "select-tag disable-user-select -prevent-pointer -disable-user-select",
        value: currValue,
        onChange: function onChange() {
          _this6.setState({
            currValue: currValue
          });
        }
      }, this.renderSelectTagOption(data)), _react["default"].createElement("ul", {
        className: "nw-option disable-user-select ".concat(_selectIsDown ? '-down' : '-up', " ").concat(isOpen ? '' : '-hidden-opts')
      }, this.renderHybridTagOption(data)), _react["default"].createElement("div", {
        className: "svg-wrap"
      }, _react["default"].createElement("svg", {
        viewBox: "64 64 896 896",
        focusable: "false",
        className: "ant-arrow ".concat(isOpen ? '-rotate' : ''),
        "data-icon": "down",
        width: "1em",
        height: "1em",
        "aria-hidden": "true"
      }, _react["default"].createElement("path", {
        d: "M884 256h-75c-5.1 0-9.9 2.5-12.9 6.6L512 654.2 227.9 262.6c-3-4.1-7.8-6.6-12.9-6.6h-75c-6.5 0-10.3 7.4-6.5 12.7l352.6 486.1c12.8 17.6 39 17.6 51.7 0l352.6-486.1c3.9-5.3.1-12.7-6.4-12.7z"
      }))));
    }
  }]);

  return Select;
}(_react.Component);

Select.propTypes = {
  disabled: _propTypes["default"].bool,
  size: _propTypes["default"].string,
  placeholder: _propTypes["default"].string,
  block: _propTypes["default"].bool,
  nullable: _propTypes["default"].bool,
  type: _propTypes["default"].string,
  data: _propTypes["default"].array,
  onChange: _propTypes["default"].func,
  detectBounds: _propTypes["default"].bool
};
var _default = Select;
exports["default"] = _default;