"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.removeBlurElem = exports.addBlurElem = exports.generateId = exports.getOffset = void 0;
var globalCallback = null;
var globalName = null;

var getOffset = function getOffset(el) {
  var rect = el.getBoundingClientRect();

  if (el) {
    var scrollLeft = window.pageXOffset || document.documentElement.scrollLeft;
    var scrollTop = window.pageYOffset || document.documentElement.scrollTop;
    return {
      top: rect.top + scrollTop,
      left: rect.left + scrollLeft
    };
  }

  return {
    top: 0,
    left: 0
  };
};

exports.getOffset = getOffset;

var generateId = function generateId() {
  return Math.floor(Math.random() * 9999) + 1 + '-' + (Math.floor(Math.random() * 9999) + 1);
};

exports.generateId = generateId;

var documentClick = function documentClick(evt) {
  var flyoutElement = document.getElementById(globalName);
  var targetElement = evt.target;
  var hasFound = false;

  do {
    if (targetElement === flyoutElement) {
      hasFound = true;
      globalCallback(hasFound);
      return;
    }

    targetElement = targetElement.parentNode;
  } while (targetElement);

  globalCallback(hasFound);
};

var addBlurElem = function addBlurElem(name, cb) {
  globalName = name;
  globalCallback = cb; // sanitize if has id=#

  globalName = globalName.trim().replace('#', ''); // sanitize if has class=.

  globalName = globalName.trim().replace('.', '');
  document.addEventListener("click", documentClick);
};

exports.addBlurElem = addBlurElem;

var removeBlurElem = function removeBlurElem() {// document.removeEventListener("click", documentClick);
};

exports.removeBlurElem = removeBlurElem;